<template>
  <div>
    <b-modal :centered="true" id="altaActivo" title="Nuevo activo" @show="resetear" hide-footer>
      <form @submit="confirmar" @submit.prevent>
        <div class="modal-body">
          <div class="row">
            <div class="col">
              <label>Nombre</label>
              <input
                type="text"
                maxlength="30"
                class="form-control"
                required
                v-model="nombreActivo"
                placeholder="Nombre del activo"
              />
            </div>
          </div>
          <div class="row" id="inputMonto">
            <div class="col-3">
              <label for="formularioMonedas">Moneda</label>
              <select class="form-control" v-model="moneda">
                <option
                  v-for="tipoMoneda in tipoMonedas"
                  :value="tipoMoneda"
                  :key="tipoMoneda"
                >{{tipoMoneda}}</option>
              </select>
            </div>
            <div class="col-9">
              <label>Monto</label>
              <input
                type="number"
                step="0.01"
                class="form-control"
                required
                min="0"
                max="999999999999999"
                v-model="montoInvertido"
                placeholder="Monto inicial invertido"
              />
            </div>
          </div>
        </div>

        <div class="modal-footer">
          <button
            type="button"
            class="btn btn-secondary"
            data-dismiss="modal"
            @click="resetear"
          >Cancelar</button>
          <button type="submit" class="btn btn-primary">Confirmar</button>
        </div>
      </form>
    </b-modal>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator";
import CotizacionDolar from "./CotizacionDolar.vue";
import axios, { AxiosResponse } from "axios";
import Cartera from "./Cartera.vue";
import { Activo } from "../domain/Activo";

@Component
export default class AltaActivo extends Vue {
  @Prop({ required: true }) tipoMonedas!: Array<String>;

  private nombreActivo: string = "";
  private montoInvertido: string = "";
  private moneda: string = "ARS";

  confirmar() {
    var activo: Activo = {
      nombre: this.nombreActivo,
      montoActual: this.montoInvertido,
      moneda: this.moneda
    };
    this.guardarActivo(activo);
    this.nombreActivo = "";
    this.montoInvertido = "";
    this.$bvModal.hide("altaActivo");
  }

  resetear() {
    this.nombreActivo = "";
    this.montoInvertido = "";
    this.moneda = "ARS";
    this.$bvModal.hide("altaActivo");
  }

  actualizarCartera() {
    this.$emit("activoNuevo");
  }

  guardarActivo(activo: Activo) {
    axios.post("http://localhost:8097/api/activo", activo).then(() => {
      this.actualizarCartera();
    });
  }

}
</script>

<style>
.modal-body {
  padding: 8px !important;
}
</style>